blog/urls.py
# blogs/urls.py

from django.urls import path
from . import views

urlpatterns = [
    path('', views.blog_index, name='blog_index'),
    path('<int:pk>/', views.blog_detail, name='blog_detail'),
    path('<category>/', views.blog_category, name="blog_category"),
]

portfolio/urls.py
from django.contrib import admin
from django.urls import include, path
from django.views.generic import RedirectView

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', RedirectView.as_view(url='projects/', permanent=True)),
    path('projects/', include('projects.urls')),
    path("blog/", include("blog.urls")),
]

projects/urls.py
from django.urls import path
from projects import views

app_name = 'projects'

urlpatterns = [
    path('', views.all_projects, name='all_projects'),
    path('<int:pk>', views.project_detail, name='project_detail')
]

blog/models.py
from django.db import models

class Post(models.Model):
    title = models.CharField(max_length=255)
    body = models.TextField()
    created_on = models.DateTimeField(auto_now_add=True)
    last_modified = models.DateTimeField(auto_now=True)
    categories = models.ManyToManyField('Category', related_name='posts')

class Category(models.Model):
    name = models.CharField(max_length=20)

class Comment(models.Model):
    author = models.CharField(max_length=60)
    body = models.TextField()
    created_on = models.DateTimeField(auto_now_add=True)
    post = models.ForeignKey('Post', on_delete=models.CASCADE)

projects/models.py
from django.db import models

# Create your models here.
class Project(models.Model):
    title = models.CharField(max_length=100)
    description = models.TextField()
    technology = models.CharField(max_length=200)
    github = models.CharField(max_length=100)
    image = models.CharField(max_length=100)

blog/forms.py
from django import forms

class CommentForm(forms.Form):
    author = forms.CharField(
        max_length=60,
        widget=forms.TextInput(attrs={
            "class": "form-control",
            "placeholder": "Your Name"
        })
    )
    body = forms.CharField(widget=forms.Textarea(
        attrs={
            "class": "form-control",
            "placeholder": "Leave a comment!"
        }
    ))

blog/views.py
from django.shortcuts import render

from blog.models import Post, Comment
from blog.forms import CommentForm


def blog_index(request):
    posts = Post.objects.all().order_by("-created_on")
    context = {"posts": posts}
    return render(request, "blog/blog_index.html", context)


def blog_category(request, category):
    posts = Post.objects.filter(categories__name__contains=category).order_by(
        "-created_on"
    )
    context = {"category": category, "posts": posts}
    return render(request, "blog/blog_category.html", context)


def blog_detail(request, pk):
    post = Post.objects.get(pk=pk)
    comments = Comment.objects.filter(post=post)

    form = CommentForm()
    if request.method == "POST":
        form = CommentForm(request.POST)
        if form.is_valid():
            comment = Comment(
                author=form.cleaned_data["author"],
                body=form.cleaned_data["body"],
                post=post,
            )
            comment.save()

    context = {"post": post, "comments": comments, "form": form}
    return render(request, "blog/blog_detail.html", context)

projects/views.py
from django.shortcuts import render

from projects.models import Project

def all_projects(request):
    #query database to return all project objects
    projects = Project.objects.all()
    return render(request, 'projects/all_projects.html', {'projects': projects})

def project_detail(request, pk):
    project = Project.objects.get(pk=pk)
    return render(request, 'projects/detail.html', {'project': project})

blog/templates/blog/blog_category.html
{% extends "base.html" %}
{% block content %}
<div class="col-md-8 offset-md-2">
    <h1>{{ category | title }}</h1>
    <hr>
    {% for post in posts %}
        <h2><a href="{% url 'blog_detail' post.pk%}">{{ post.title }}</a></h2>
        <small>
            {{ post.created_on.date }} |&nbsp;
            Categories:&nbsp;
            {% for category in post.categories.all %}
            <a href="{% url 'blog_category' category.name %}">
                {{ category.name }}
            </a>&nbsp;
            {% endfor %}
        </small>
        <p>{{ post.body | slice:":400" }}...</p>
    {% endfor %}
</div>
{% endblock %}

blog/templates/blog/blog_detail.html
{% extends "base.html" %}
{% block content %}
<div class="col-md-8 offset-md-2">
    <h1>{{ post.title }}</h1>
    <small>
        {{ post.created_on.date }} |&nbsp;
        Categories:&nbsp;
        {% for category in post.categories.all %}
        <a href="{% url 'blog_category' category.name %}">
            {{ category.name }}
        </a>&nbsp;
        {% endfor %}
    </small>
    <p>{{ post.body | linebreaks }}</p>
    <h3>Leave a comment:</h3>
    <form action="/blog/{{ post.pk }}/" method="post">
        {% csrf_token %}
        <div class="form-group">
            {{ form.author }}
        </div>
        <div class="form-group">
            {{ form.body }}
        </div>
        <button type="submit" class="btn btn-primary">Submit</button>
    </form>
    <h3>Comments:</h3>
    {% for comment in comments %}
    <p>
        On {{comment.created_on.date }}&nbsp;
        <b>{{ comment.author }}</b> wrote:
    </p>
    <p>{{ comment.body }}</p>
    <hr>
    {% endfor %}
</div>
{% endblock %}

blog/templates/blog/blog_index.html
{% extends 'base.html' %}

{% block content %}
<div class="col-md-8 offset-md-2">
    <h1 class="text-center display-4">Blog Index</h1>
    <hr class="my-4">
    {% for post in posts %}
    <div class="card mb-4">
        <div class="card-body">
            <h2 class="card-title"><a href="{% url 'blog_detail' post.pk%}" class="text-dark">{{ post.title }}</a></h2>
            <small class="text-muted">
                {{ post.created_on.date }} | Categories:
                {% for category in post.categories.all %}
                <a href="{% url 'blog_category' category.name %}" class="text-primary">
                    {{ category.name }}
                </a>
                {% if not forloop.last %}&nbsp;{% endif %}
                {% endfor %}
            </small>
            <p class="card-text mt-3">{{ post.body | slice:":400" }}...</p>
            <a href="{% url 'blog_detail' post.pk%}" class="btn btn-primary btn-sm">Read More</a>
        </div>
    </div>
    {% endfor %}
</div>
{% endblock %}

portfolio/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Portfolio</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <link href="https://fonts.googleapis.com/css?family=Roboto:400,700" rel="stylesheet">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <style>
        /* Custom styles */
        /* TODO: Make squares equal and smart truncate summary*/
        body {
            font-family: 'Roboto', sans-serif;
        }

        .navbar {
            background-color: #f8f9fa;
        }

        .navbar-brand {
            font-weight: bold;
            color: #333;
        }

        .navbar-toggler {
            border-color: #333;
        }

        .navbar-nav .nav-item .nav-link {
            color: #333;
            font-weight: bold;
        }

        .navbar-nav .nav-item .nav-link:hover,
        .navbar-nav .nav-item .nav-link:focus {
            color: #007bff;
        }

        .container {
            margin-top: 30px;
        }

        /* Additional styles */
        h1 {
            font-size: 48px;
            color: #333;
            margin-bottom: 30px;
        }

        p {
            font-size: 18px;
            color: #555;
            margin-bottom: 20px;
        }

        .btn-primary {
            background-color: #007bff;
            border-color: #007bff;
            font-weight: bold;
            transition: background-color 0.3s ease;
        }

        .btn-primary:hover,
        .btn-primary:focus {
            background-color: #0056b3;
            border-color: #0056b3;
        }

        .footer {
            background-color: #f8f9fa;
            padding: 20px 0;
            text-align: center;
        }

        .footer p {
            margin-bottom: 0;
            font-size: 12px;
        }

        img {
            padding: 10px;
        }
    </style>
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-light">
        <div class="container">
            <a class="navbar-brand" href="{% url 'projects:all_projects' %}">Cory Chambers</a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
    
            <div class="collapse navbar-collapse" id="navbarSupportedContent">
                <ul class="navbar-nav ml-auto">
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'projects:all_projects' %}">Projects</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'blog_index' %}">Blog</a>
                    </li>
                    <!-- Add more navbar items as needed -->
                </ul>
            </div>
        </div>
    </nav>
    <div class="container">
        {% block content %}
    
        {% endblock %}
    </div>
    <div class="footer">
        <p>&copy; 2023 Cory Chambers. All rights reserved.</p>
    </div>
    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js" integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI" crossorigin="anonymous"></script>
</body>
</html>

projects/templates/projects/all_projects.html
{% extends 'base.html' %}

{% load static %}

{% block content %}
<div class="container">
    <h1 class="text-center mt-5">Projects</h1>
    <div class="row">
        {% for project in projects %}
        <div class="col-md-4">
            <a href="{% url 'projects:project_detail' project.pk %}" class="card-link">
                <div class="card mb-4 rounded shadow-sm">
                    <img class="card-img-top rounded-top" src="{% static project.image %}" alt="{{ project.title }}">
                    <div class="card-body text-center">
                        <h5 class="card-title">{{ project.title }}</h5>
                        <p class="card-text">Tech: {{ project.technology }}</p>
                        <p class="card-text">{{ project.description|truncatechars:100 }}</p>
                        <a href="{% url 'projects:project_detail' project.pk %}" class="btn btn-primary btn-read-more">Read More</a>
                    </div>
                </div>
            </a>
        </div>
        {% endfor %}
    </div>
</div>

<style>
    .card {
        transition: transform 0.3s;
        cursor: pointer;
    }

    .card:hover {
        transform: translateY(-5px);
    }

    .card-img-top {
        object-fit: scale-down;
        height: 200px;
    }

    .card-title {
        font-weight: bold;
        margin-bottom: 10px;
    }

    .btn-read-more {
        background-color: #007bff;
        border-color: #007bff;
        font-weight: bold;
        transition: background-color 0.3s ease;
    }

    .btn-read-more:hover,
    .btn-read-more:focus {
        background-color: #0056b3;
        border-color: #0056b3;
    }
</style>

{% endblock %}

projects/templates/projects/detail.html
{% extends 'base.html' %}

{% load static %}

{% block content %}
<div class="container">
    <div class="row justify-content-center">
        <div class="col-lg-8">
            <h1 class="display-4 text-center">{{ project.title }}</h1>
            <div class="card mb-4">
                <div class="row no-gutters">
                    <div class="col-md-4">
                        <img src="{% static project.image %}" alt="{{ project.description }}" class="card-img">
                    </div>
                    <div class="col-md-8">
                        <div class="card-body">
                            <p class="card-text">{{ project.description }}</p>
                            <hr>
                            <h5 class="card-title">Technology</h5>
                            <p class="card-text">{{ project.technology }}</p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<style>
    .display-4 {
        margin-top: 30px;
        margin-bottom: 20px;
        font-weight: bold;
    }

    .card {
        border: none;
        box-shadow: 0px 4px 8px rgba(0, 0, 0, 0.1);
    }

    .card-img {
        width: 100%;
        height: auto;
        border-radius: 4px 0 0 4px;
    }

    .card-body {
        padding: 20px;
    }

    .card-title {
        font-size: 18px;
        font-weight: bold;
        margin-bottom: 10px;
    }

    .card-text {
        font-size: 16px;
        color: #555;
    }
</style>

{% endblock %}